@echo off

REM ********************************************************
REM *      Ce programme est livr sans aucune garantie     *
REM *               Tutoriel disponible ici :              *
REM * http://biblio.scl.free.fr/lire.php?doc=Windows_patch *
REM   ----------------------------------------------------
REM *      This software is given without any garantee     *
REM *                Tutorial available here:              *
REM * http://biblio.scl.free.fr/lire.php?doc=Windows_patch *
REM ********************************************************

IF EXIST "_patchList.tmp" DEL "_patchList.tmp"

if "%1"=="" GOTO PrimAffiche
if "%*"=="/2" GOTO SecondAffiche
if "%1"=="/?" GOTO Help
if "%1"=="/??" GOTO Aide
GOTO Diff

:PrimAffiche
CALL :PrimList
GOTO Affiche

:SecondAffiche
CALL :SecondList
GOTO Affiche

:Affiche
FOR /F %%i IN (_patchList.tmp) DO ECHO %%i
DEL "_patchList.tmp"
GOTO Extra

:Kb
SET kb=%1
IF "%kb:~0,2%" == "KB" ECHO %kb:~0,8% >> "_patchList.tmp"
GOTO Fin

REM ---------------

:PrimList
FOR /F "usebackq" %%i IN (`dir /b /ah %SystemRoot%\$NT*`) DO CALL :PrimParse %%i
GOTO Fin

:PrimParse
SETLOCAL
SET name=%1
CALL :Kb %name:~12,-1%
ENDLOCAL
GOTO Fin

REM ---------------

:SecondList
SETLOCAL
REM Pour Windows 2000: HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Updates\Windows 2000
SET reg=HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Updates\Windows XP
FOR /F "usebackq skip=4 tokens=1 delims=@" %%i IN (`REG QUERY "%reg%"`) DO CALL :Sub %%i
ENDLOCAL
GOTO Fin

:Sub
SET line=%*
CALL SET line=%%line:%reg%\=%%
IF "%line:~0,2%" == "KB" CALL :Kb %line%
IF "%line:~0,2%" == "SP" GOTO :Sp
GOTO Fin

:Sub2
SET line2=%*
CALL SET line2=%%line2:%reg%\%line%\=%%
CALL :Kb %line2%
GOTO Fin

:Sp
FOR /F "usebackq skip=4 tokens=1 delims=@" %%i IN (`REG QUERY "%reg%\%line%"`) DO CALL :Sub2 %%i
GOTO Fin

REM ---------------

:Cmp
SET cmp=%3
REM SET cmp=%cmp:~12,8%

SET cmp=%cmp:kb=KB%
REM TODO UpperCase

REM ECHO %isEqual% - (%2, %cmp%)

IF "%2" == "%cmp%" SET isEqual=1
IF "%1" == "1" SET isEqual=1

REM ECHO %isEqual%

GOTO Fin

:Find
SETLOCAL
SET ref=%1
SET ref=%ref:kb=KB%
SET isEqual=0
FOR /F %%j IN (%2) DO CALL :Cmp !isEqual! %ref% %%j
IF "%isEqual%" == "0" ECHO %ref%
ENDLOCAL
GOTO Fin

:Diff
SETLOCAL
SET file=%1
IF "%1" == "/2" (
        CALL :SecondList
        SET file=%2
) ELSE (
        CALL :PrimList
)
ECHO Veuillez patienter / Please wait...
ECHO.
FOR /F "eol=#" %%i IN (%file%) DO CALL :Find %%i _patchlist.tmp
DEL _patchlist.tmp
ENDLOCAL
GOTO Extra

REM ---------------------------------------------------

:Help
ECHO WinPatch, Version 1.0 - Zefiris - 2006, 13 July
ECHO This script enumerates Windows Patches installed on your system
ECHO      and gives a list of missing ones based on a reference file.
ECHO   http://biblio.scl.free.fr/lire.php?doc=Windows_Patch
ECHO.
ECHO WinPatch [/2] [Filename]
ECHO.
ECHO   /2         Patch listing based on registry instead of File System
ECHO   FileName   Compare your configuration to a specified reference file
ECHO.  /??        This help section in French
ECHO.
GOTO Fin

:Aide
ECHO WinPatch, Version 1.0 - Zfiris - 13 Juillet 2006
ECHO Ce script liste les Patchs Windows installs sur votre systme.
ECHO Il fournit en outre une liste des patchs manquants base sur un fichier de rfrence
ECHO   http://biblio.scl.free.fr/lire.php?doc=Windows_Patch
ECHO.
ECHO WinPatch [/2] [Fichier]
ECHO.
ECHO   /2         Liste des Patch base sur le registre et non sur le systme de fchiers
ECHO   Fichier    Compare votre configuration systme  un fichier de rfrence
ECHO.
GOTO Fin

:Extra
ECHO.
ECHO Scan termin / Done.
ECHO.

:Fin
